<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Under Water Drone: Plik źródłowy scene.cpp</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Under Water Drone
   &#160;<span id="projectnumber">0.1</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Wygenerowano przez Doxygen 1.8.17 -->
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('../../',false,false,'search.php','Szukaj');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('da/d33/scene_8cpp_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">scene.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../da/d33/scene_8cpp.html">Idź do dokumentacji tego pliku.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="../../d5/dd8/scene_8hh.html">scene.hh</a>&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">using namespace </span>std::this_thread;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">using namespace </span>std::chrono;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno"><a class="line" href="../../d6/db5/class_scene.html#ad10176d75a9cc0da56626f682d083507">   10</a></span>&#160;<a class="code" href="../../d6/db5/class_scene.html#ad10176d75a9cc0da56626f682d083507">Scene::Scene</a>() {</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    link.Init();</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    link.SetDrawingMode(<a class="code" href="../../d2/d4b/namespace_pz_g.html#a4360c76a1dbf714a19a0d97fe56e0660aa7ef207217913b87d83fdf559d8368c7">PzG::DM_3D</a>);</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    link.AddFilename(<a class="code" href="../../d8/dc1/classbottom_surface.html#a17014c3403a3813c8b113d783879c5fe">bottomSurface::kGroundFile</a>.c_str(), <a class="code" href="../../d2/d4b/namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    link.AddFilename(<a class="code" href="../../d0/ddf/classwater_surface.html#a294c9960b9d4aaacce830f087302a1ca">waterSurface::kWaterSurfaceFile</a>.c_str(), <a class="code" href="../../d2/d4b/namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    draw(kDroneFile);</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    link.AddFilename(<a class="code" href="../../d5/d02/class_drone.html#a56f1e93b78d78a6d64929288eee02610">Drone::kDroneFile</a>.c_str(), <a class="code" href="../../d2/d4b/namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    link.Draw();</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;}</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="../../d6/db5/class_scene.html#a3991345d3b38355077c2a8615fdeae05">   24</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="../../d6/db5/class_scene.html#a3991345d3b38355077c2a8615fdeae05">Scene::checkCollision</a>(<span class="keyword">const</span> <a class="code" href="../../d5/db2/class_vector.html">Vector3D</a> &amp;vector) {</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordflow">if</span> (vector[2] &gt; waterLevel){</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot; Dron za bardzo sie wynurzyl &quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    }</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordflow">if</span> (vector[2] &lt; bottomLevel) {</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot; Dron dotknal dna &quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    }</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;}</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="../../d6/db5/class_scene.html#a0a3d83da2246b9e98c9e04cef38e1778">   39</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="../../d6/db5/class_scene.html#a0a3d83da2246b9e98c9e04cef38e1778">Scene::animation</a>(<span class="keywordtype">double</span> rotateAngle) {</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; frames; ++i) {</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <a class="code" href="../../d5/d02/class_drone.html#ad657730896d4edb8e9b6ecb5dec69413">Drone::rotate</a>(rotateAngle, frames);</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        link.Draw();</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        sleep_for(microseconds(frameFreeze));</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    }</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;}</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="../../d6/db5/class_scene.html#a45aadc8e5a63422972db07fd9b0e8b76">   48</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="../../d6/db5/class_scene.html#a0a3d83da2246b9e98c9e04cef38e1778">Scene::animation</a>(<span class="keyword">const</span> <span class="keywordtype">double</span> &amp;angleChange, <span class="keyword">const</span> <span class="keywordtype">double</span> &amp;distance) {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; frames; ++i) {</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keywordflow">if</span> (checkCollision(<a class="code" href="../../d5/d02/class_drone.html#a72b51743436557dbb7c3d4dae30f09c4">Drone::moveForward</a>(angleChange, distance, frames))) {</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        }</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        link.Draw();</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        sleep_for(microseconds(frameFreeze));</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    }</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclass_drone_html_a72b51743436557dbb7c3d4dae30f09c4"><div class="ttname"><a href="../../d5/d02/class_drone.html#a72b51743436557dbb7c3d4dae30f09c4">Drone::moveForward</a></div><div class="ttdeci">Vector3D moveForward(const double &amp;angleChange, const double &amp;distance, const int &amp;frames)</div><div class="ttdoc">Zadaje ruch na wprost Korzystając z funkcji, która wylicza wektor przesunięcia wykonuje ruch drona na...</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/dd8/drone_8cpp_source.html#l00003">drone.cpp:3</a></div></div>
<div class="ttc" id="anamespace_pz_g_html_ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec"><div class="ttname"><a href="../../d2/d4b/namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a></div><div class="ttdeci">@ LS_CONTINUOUS</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d35/gnuplot__link_8hh_source.html#l00048">gnuplot_link.hh:48</a></div></div>
<div class="ttc" id="aclass_scene_html_a0a3d83da2246b9e98c9e04cef38e1778"><div class="ttname"><a href="../../d6/db5/class_scene.html#a0a3d83da2246b9e98c9e04cef38e1778">Scene::animation</a></div><div class="ttdeci">void animation(double rotateAngle)</div><div class="ttdoc">Realizuje animacje ruchu.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d33/scene_8cpp_source.html#l00039">scene.cpp:39</a></div></div>
<div class="ttc" id="aclasswater_surface_html_a294c9960b9d4aaacce830f087302a1ca"><div class="ttname"><a href="../../d0/ddf/classwater_surface.html#a294c9960b9d4aaacce830f087302a1ca">waterSurface::kWaterSurfaceFile</a></div><div class="ttdeci">const std::string kWaterSurfaceFile</div><div class="ttdoc">Plik z zapisanymi współrzędnymi wody.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/d9a/water_surface_8hh_source.html#l00015">waterSurface.hh:15</a></div></div>
<div class="ttc" id="aclassbottom_surface_html_a17014c3403a3813c8b113d783879c5fe"><div class="ttname"><a href="../../d8/dc1/classbottom_surface.html#a17014c3403a3813c8b113d783879c5fe">bottomSurface::kGroundFile</a></div><div class="ttdeci">const std::string kGroundFile</div><div class="ttdoc">Plik z zapisanymi współrzędnymi dna.</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d7f/bottom_surface_8hh_source.html#l00015">bottomSurface.hh:15</a></div></div>
<div class="ttc" id="aclass_drone_html_ad657730896d4edb8e9b6ecb5dec69413"><div class="ttname"><a href="../../d5/d02/class_drone.html#ad657730896d4edb8e9b6ecb5dec69413">Drone::rotate</a></div><div class="ttdeci">void rotate(double angleChange, const int &amp;frames)</div><div class="ttdoc">Obraca drona o zadany kąt.</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/dd8/drone_8cpp_source.html#l00010">drone.cpp:10</a></div></div>
<div class="ttc" id="aclass_scene_html_ad10176d75a9cc0da56626f682d083507"><div class="ttname"><a href="../../d6/db5/class_scene.html#ad10176d75a9cc0da56626f682d083507">Scene::Scene</a></div><div class="ttdeci">Scene()</div><div class="ttdoc">Konstruktor dla klasy Scene.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d33/scene_8cpp_source.html#l00010">scene.cpp:10</a></div></div>
<div class="ttc" id="anamespace_pz_g_html_a4360c76a1dbf714a19a0d97fe56e0660aa7ef207217913b87d83fdf559d8368c7"><div class="ttname"><a href="../../d2/d4b/namespace_pz_g.html#a4360c76a1dbf714a19a0d97fe56e0660aa7ef207217913b87d83fdf559d8368c7">PzG::DM_3D</a></div><div class="ttdeci">@ DM_3D</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d35/gnuplot__link_8hh_source.html#l00042">gnuplot_link.hh:42</a></div></div>
<div class="ttc" id="aclass_drone_html_a56f1e93b78d78a6d64929288eee02610"><div class="ttname"><a href="../../d5/d02/class_drone.html#a56f1e93b78d78a6d64929288eee02610">Drone::kDroneFile</a></div><div class="ttdeci">const std::string kDroneFile</div><div class="ttdoc">Nazawa pliku, w którym jest zapisany model drona.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/dcb/drone_8hh_source.html#l00023">drone.hh:23</a></div></div>
<div class="ttc" id="aclass_vector_html"><div class="ttname"><a href="../../d5/db2/class_vector.html">Vector&lt; double, 3 &gt;</a></div></div>
<div class="ttc" id="ascene_8hh_html"><div class="ttname"><a href="../../d5/dd8/scene_8hh.html">scene.hh</a></div></div>
<div class="ttc" id="aclass_scene_html_a3991345d3b38355077c2a8615fdeae05"><div class="ttname"><a href="../../d6/db5/class_scene.html#a3991345d3b38355077c2a8615fdeae05">Scene::checkCollision</a></div><div class="ttdeci">bool checkCollision(const Vector3D &amp;vector)</div><div class="ttdoc">Sprawdza kolizję drona z dnem lub powierzchnią wody.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d33/scene_8cpp_source.html#l00024">scene.cpp:24</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_167790342fb55959539d550b874be046.html">project</a></li><li class="navelem"><a class="el" href="../../dir_f77a644fded742ea05ed17fa0fdf6fe1.html">src</a></li><li class="navelem"><a class="el" href="../../da/d33/scene_8cpp.html">scene.cpp</a></li>
    <li class="footer">Wygenerowano przez
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
